## gnat-gps 6.1.2016

=== cli/Makefile ===
GPRBUILD=gprbuild
GPRCLEAN=gprclean

all default:
	$(GPRBUILD) -p -Pcli

clean:
	$(GPRCLEAN) -q -r -Pcli

=== gps/Makefile ===
SYS := $(shell gcc -dumpmachine)
ifeq ($(OS),Windows_NT)
	OS := Windows_NT
else
	ifneq (, $(findstring darwin, $(SYS)))
OS := osx
else
	OS := unix
endif
endif

ifeq ($(OS),Windows_NT)
   LN = cp -p
else
   LN = ln -s
endif

GPRBUILD=gprbuild
GPRBUILD_FLAGS=
PYTHON=python

Build?=Debug

ifeq ($(Build),Production)
  GPRBUILD_BUILD_TYPE_FLAGS=-XBuild=Production -XGnatcoll_Build=Production -XOS=${OS}
else
  GPRBUILD_BUILD_TYPE_FLAGS=-XBuild=Debug -XGnatcoll_Build=Debug -XOS=${OS}
endif

.PHONY: default resources do_links all clean

default: all

gps_and_cli: all
	$(MAKE) -C ../cli all

include ../Makefile.gnat

# NOTE: we need to build gnatcoll separately, since we cannot use
# gnat.adc (No_Tasking restriction) on all gnatcoll sources.
all: resources do_links
	cd ../kernel/src; ${PYTHON} hooks.py
	$(GPRBUILD) $(GPRBUILD_FLAGS) -m -ws -P../spark/spark
	$(GPRBUILD) $(GPRBUILD_FLAGS) -m -p -ws -XTP_TASKING=No_Tasking \
	  $(GPRBUILD_BUILD_TYPE_FLAGS) -Pgps -largs `pkg-config gmodule-2.0 --libs`

resources:
ifeq ($(OS),Windows_NT)
	@cd src; windres gps.rc -O coff -o ../obj/gps.res
	$(MAKE) -s -C ../common/expect
endif

# If gnatlib/gnat_src exists, we use symbolic links to find the files we
# need, otherwise we assume that cron-src has put them in gnat/ already.
# Those few files are needed to generate support plug-ins for GPS.
do_links:
ifneq ($(wildcard ../gnat_src),)
	-@$(foreach f,$(GNAT_SOURCES), \
	  $(LN) ../gnat_src/$(f) ../gnat > /dev/null 2>&1 ;)
endif

install:
	$(MAKE) -C .. install

clean:
ifeq ($(OS),Windows_NT)
	$(MAKE) -s -C ../common/expect clean
endif
	-gprclean -q -r -Pgps

=== libclang/Makefile ===
TMP_GEN_DIR=gen
CLANG_SRC_DIR=cfe-3.5.0.src
CLANG_INCLUDE_DIR=$(shell pwd)/$(CLANG_SRC_DIR)/include
CLANG_INCLUDE_DIR_C=$(CLANG_INCLUDE_DIR)/clang-c
DL=wget
CLANG_SRC_FNAME=$(CLANG_SRC_DIR).tar.xz
CLANG_SRC_LINK=http://llvm.org/releases/3.5.0/$(CLANG_SRC_FNAME)

ifeq ($(wildcard binding/clang.ads),)
all: clean_imports
else
all:
endif

init: init_gen init_clang_src

init_gen:
	mkdir -p $(TMP_GEN_DIR)

init_clang_src:
	if [ ! -d $(CLANG_SRC_DIR) ]; then $(DL) $(CLANG_SRC_LINK) && tar xvf $(CLANG_SRC_FNAME) && rm $(CLANG_SRC_FNAME); fi

generate_fdump_bindings: init
	cd $(TMP_GEN_DIR) && g++ -I/usr/include/x86_64-linux-gnu -I$(CLANG_INCLUDE_DIR) -DNDEBUG -D_GNU_SOURCE -D__STDC_CONSTANT_MACROS -D__STDC_FORMAT_MACROS -D__STDC_LIMIT_MACROS -U__cplusplus -c -D_Bool=bool -fdump-ada-spec $(CLANG_INCLUDE_DIR_C)/*.h

clean_imports: generate_fdump_bindings
	sed -e 's/pragma Import (CPP, \(.*\), ".*");/pragma Import (C, \1, "\1");/g' -i $(TMP_GEN_DIR)/clang_c_*_h.ads
	sed -e 's/\(with Interfaces.C; use Interfaces.C;\)/pragma Warnings (Off); \1 pragma Warnings (On);/g' -i $(TMP_GEN_DIR)/clang_c_*_h.ads
	sed -e 's/\(^.*[t|T]ime.*$\\)/--  \\1/g' -i $(TMP_GEN_DIR)/clang_c_index_h.ads
	rm $(TMP_GEN_DIR)/*time* $(TMP_GEN_DIR)/*types*

clean:
	rm $(TMP_GEN_DIR) -rf

distclean: clean
	rm $(CLANG_SRC_DIR) -rf

=== debian/changelog ===
gnat-gps (6.1.2016-1ubuntu1) artful; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - debian/control: gnat-gps: Recommend gdb | gdb-minimal.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 02 Sep 2017 00:02:08 +0200

gnat-gps (6.1.2016-1) unstable; urgency=medium

  * New upstream release GPL-2016.
    Disable new CLang module because it causes a link failure.
  * New files with the Expat license.
  * Build against latest gnatcoll, gtkada, templates-parser, xmlada.
    Replace libgnatprj, removed from GCC, with gpr from gprbuild.
    Patches to use Debian versions of gnatcoll and gpr.
  * Build-Depend: gnatcoll-xref (new), latexmk (for sphinx PDF module),
    texlive-plain-generic (renaming).
  * Update icon reference in desktop file. Closes: #855649.
  * Prettier watch file with version 4 format.
  * Debhelper 10.
  * PDFLaTeX now deals with SOURCE_DATE_EPOCH without faketime.
  * Standards-Version: 4.1.0.
    HTTPS copyright format URL. Allow DEB_BUILD_OPTIONS=nodoc
  * Update Vcs-Mtn URL.
  * Drop obsolete preinst scripts, 5.0-13 not in oldstable anymore.
  * Disable sphinx parallelism because of #869098.
  * Fix various typos or file permissions.

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 23 Aug 2017 10:06:52 +0200

gnat-gps (6.1.1-1ubuntu2) zesty; urgency=medium

  * No-change rebuild for ada transition.

 -- Adam Conrad <adconrad@ubuntu.com>  Fri, 07 Apr 2017 08:04:46 -0600

gnat-gps (6.1.1-1ubuntu1) yakkety; urgency=medium

  * Merge from Debian unstable.  Remaining changes:
    - debian/control: gnat-gps: Recommend gdb | gdb-minimal.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 05 Aug 2016 10:32:37 +0200

=== debian/control ===
Source: gnat-gps
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Ludovic Brenta <lbrenta@debian.org>
Uploaders: Xavier Grave <xavier.grave@csnsm.in2p3.fr>,
 Nicolas Boulenguez <nicolas@debian.org>
Build-Depends: debhelper (>= 10), dpkg-dev (>= 1.16.1),
 gnat,
 libgpr1-dev,
 libxmlada-unicode7-dev,
 libxmlada-input7-dev,
 libxmlada-sax7-dev,
 libxmlada-dom7-dev,
 gprbuild (>= 2017),
# gprbuild removing auto.cgpr after the build.
 libtemplates-parser11.10.2-dev,
 pkg-config, libglib2.0-dev, libgtk-3-dev,
 libgtkada16.1.0-dev,
 libgnatcoll-python16.1.0-dev,
 libgnatcoll16.1.0-dev,
 libgnatcoll-gtk16.1.0-dev,
 libgnatcoll-sqlite16.1.0-dev,
 libgnatcoll-xref17.0.2017-dev
# libclang-dev See TODO
Build-Depends-Indep:
# Sphinx uses graphs for Python inheritance trees, in gps.py for example.
 graphviz,
 libjs-prototype (>= 1.6.1),
 libjs-scriptaculous (>= 1.5.1),
 latexmk,
# Sphinx >= 1.6 uses the latexmk driver.
 texlive-fonts-recommended,
# sphinx-doc requires iftex.sty:
 texlive-plain-generic,
 texlive-latex-extra,
# dh_sphinxdoc
 sphinx-common,
# other js libraries
 dh-linktree,
 python-sphinx
Standards-Version: 4.1.0
Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.gnat-gps
Vcs-Mtn: mtn://www.ada-france.org?org.debian.gnat-gps
Homepage: http://libre.adacore.com/libre/tools/gps

Package: gnat-gps
Architecture: any
Depends: gnat-gps-common (=${source:Version}), ${shlibs:Depends}, ${misc:Depends},
# Required for any compilation.
 gprbuild,
# Required by the Python scripts describing the GUI.
 python-gi,
# libgnatcoll-sqlite-bin provides gnatinspect and gnat-gps runs it.
 libgnatcoll-sqlite-bin
Recommends: gnat (>= 4.9), gdb | gdb-minimal (>= 6.8),
 gnat-gps-doc (= ${source:Version})
 ,python-jedi
 ,python-pep8
# Recommends: -doc because the welcome page displays documentation.
Description: integrated development environment for C and Ada
 GNAT Programming Studio is a complete integrated development environment
 that gives access to a wide range of tools and integrates them smoothly.
 .
 GPS gives access to built-in file editing; HTML based help system;
 complete compile/build/run cycle; intelligent source navigation;
 project management; general graph technology giving access to many
 different browsers such as source dependency, project dependency, call
 graphs, etc.; fully integrated visual debugger, based on the GVD
 technology, and enhanced for inclusion in GPS; generic version control
 system, providing access to CVS, ClearCase, and possibly others in the
 future; many other tools such as a visual comparison, automatic
 generation of files, source reformatting.
 .
 GPS is fully customizable, providing several levels of customizations:
 a first level, available through the preferences dialog; a second
 level, which allows you to customize your menu items, tool bar and key
 bindings; a third level, which allows you to automate processing
 through scripts; and a fourth level, which allows any kind of very
 specific or tight integration, due to the open nature of GPS, and to
 its architecture.
 .
 GPS also integrates with existing editors such as Emacs and Vi.
 .
 This package also provides related command line tools:
  - gnatdoc extracts documentation from comments in Ada sources
  - gnatspark runs a spark tool according to a GNAT project
  - gps_cli is a command-line interface for gnat-gps

Package: gnat-gps-doc
Architecture: all
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Recommends: ada-reference-manual-2012
Section: doc
Description: integrated development environment for C and Ada (documentation)
 GNAT Programming Studio is a complete integrated development environment
 that gives access to a wide range of tools and integrates them smoothly.
 .
 This package contains the documentation in HTML and PDF formats.
 This documentation consists of:
  - the GPS Tutorial: building Hello, World with the GPS
  - a User's Guide: using the GPS for multi-language projects
  - a Programmer's Manual: extending the GPS with new modules
  - an user's guide for the gnatdoc command line tool

Package: gnat-gps-common
Architecture: all
Depends: ${misc:Depends}
Breaks: gnat-gps (<< 5.0)
Replaces: gnat-gps (<< 5.0)
Description: integrated development environment for C and Ada (common files)
 GNAT Programming Studio is a complete integrated development environment
 that gives access to a wide range of tools and integrates them smoothly.
 .
 This package contains images, templates and plug-ins required at run time
 by GPS.

=== debian/rules ===
#!/usr/bin/make -f

##############
# Legal stuff
##############

# Copyright (c) 2003-2006, 2011-2014 Ludovic Brenta <lbrenta@debian.org>
# Copyright (c) 2010-2017 Nicolas Boulenguez <nicolas@debian.org>

# This build script is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3 of the
# License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# On Debian systems, the full text of the GPL is in the file
# /usr/share/common-licenses/GPL-3.

.SUFFIXES:

########################
# Guess some variables.
########################

gnat_version := $(shell gnatgcc -dumpversion | sed 's/\..*//')

DEB_BUILD_MAINT_OPTIONS := hardening=+all
include /usr/share/dpkg/default.mk
# Set CFLAGS (handling noopt from DEB_BUILD_OPTIONS), LDFLAGS,
# DEB_HOST_GNU_TYPE, DEB_HOST_ARCH, DEB_VERSION...
include /usr/share/ada/debian_packaging-$(gnat_version).mk

PKG_CONFIG_LIBRARIES := gtk+-3.0 glib-2.0

# CLANG_VERSION := $(shell dpkg -s libclang-dev \
#   | sed -nr '/^Depends: libclang-(.*)-dev.*/{s//\1/p;q}')
# LIBS := -L/usr/lib/llvm-$(CLANG_VERSION)/lib -lclang -lstdc++

######################################################################
%:
	dh $@

# Do not try to call an upstream configure or Makefile.
.PHONY: $(addprefix override_dh_auto_, \
  clean configure build-arch build-indep test install)

######################################################################

GPS_WELCOME := docs/gps-welcome.html docs/gps-welcome-public.html
override_dh_auto_build-indep: $(GPS_WELCOME)
$(GPS_WELCOME): %: %.in
	sed -e 's/@GPS_VERSION@/$(DEB_VERSION_UPSTREAM)/' $< > $@
override_dh_auto_clean::
	rm -f $(GPS_WELCOME)

PROTOCOLS_PY := share/support/core/protocols.py
override_dh_auto_build-indep: $(PROTOCOLS_PY)
$(PROTOCOLS_PY): %: %.in
	sed -e 's/@SSH_ESCAPE@/~/' $< > $@
override_dh_auto_clean::
	rm -f $(PROTOCOLS_PY)

# Note: the script generates both Ada and Python sources, the latter
# are embedded into the users_guide.
override_dh_auto_build-arch: docs/users_guide/GPS/generated_hooks.py
docs/users_guide/_build: docs/users_guide/GPS/generated_hooks.py
docs/users_guide/GPS/generated_hooks.py: kernel/src/hooks.py
	rm -fr kernel/generated
	mkdir kernel/generated
	cd kernel/src && python hooks.py
override_dh_auto_clean::
	rm -fr kernel/generated docs/users_guide/GPS/generated_hooks.py

# override_dh_auto_build-arch: libclang/gen
libclang/gen:
	$(MAKE) -C libclang \
	  CLANG_SRC_DIR=/usr/lib/llvm-$(CLANG_VERSION) \
	  GCC_DUMPMACHINE=$(DEB_HOST_MULTIARCH)
override_dh_auto_clean::
	rm -fr libclang/gen

GNAT_SWITCHES_PY := share/support/core/gnat_switches.py
override_dh_auto_build-indep: $(GNAT_SWITCHES_PY)
$(GNAT_SWITCHES_PY): distrib/gnat_switches.py \
                     gnat/building_executable_programs_with_gnat.rst
	python distrib/gnat_switches.py > $@
override_dh_auto_clean::
	rm -f $(GNAT_SWITCHES_PY)

GNAT_RUNTIME_PLUG_IN := share/support/core/runtime.py
override_dh_auto_build-indep: $(GNAT_RUNTIME_PLUG_IN)
share/support/core/runtime.py: distrib/from_impunit.pl gnat/impunit.adb
	cd distrib && perl from_impunit.pl
override_dh_auto_clean::
	rm -f  $(GNAT_RUNTIME_PLUG_IN)

######################################################################
override_dh_auto_build-arch:
	gprbuild $(BUILDER_OPTIONS) -k -Pdebian/build_gps.gpr \
	  $(foreach v,ADAFLAGS CFLAGS CPPFLAGS LDFLAGS LIBS,"-X$(v)=$($(v))") \
	  "-XPKG_CONFIG_CFLAGS=`pkg-config --cflags $(PKG_CONFIG_LIBRARIES)`" \
	  "-XPKG_CONFIG_LIBS=`pkg-config --libs $(PKG_CONFIG_LIBRARIES)`"
override_dh_auto_clean::
	rm -f obj/*

CONFIG_ADS := common/core/src/config.ads
override_dh_auto_build-arch: $(CONFIG_ADS)
$(CONFIG_ADS): %: %.in
	sed -e 's/@CURRENT_YEAR@/2015/' \
	    -e 's/@GPS_VERSION@/$(DEB_VERSION_UPSTREAM)/' \
	    -e 's/@TARGET@/$(DEB_HOST_GNU_TYPE))/' \
	    -e 's/@TARGET_IS_DARWIN@/False/' \
	    -e 's!@prefix@!/usr!' \
	    -e 's/@HOST_TYPE@/Unix/' \
	    -e 's/@STRIP_CR@/False/' \
	    -e 's/@CAN_OUTPUT@/True/' \
	    -e 's!@EXEC_COMMAND@!/bin/sh -c!' \
	    -e 's/@DEFAULT_PS@/ps/' \
	    -e 's/@PRINT_CMD@/lpr/' \
	    -e 's/@OPAQUE_MDI@/True/' \
	    -e 's/@DIFF_CMD@/diff -u/' \
	    -e 's/@DIFF3_CMD@/diff3/' \
	    -e 's/@PATCH_CMD@/patch/' \
	    -e 's/@EXECUTION_WINDOW@/True/' \
	    -e 's/@CHARSET@/UTF-8/' $< > $@
override_dh_auto_clean::
	rm -f $(CONFIG_ADS)

######################################################################
DOCS := \
 docs/users_guide/_build \
 docs/tutorial/_build \
 docs/programmers_guide/_build \
 docs/release_notes/build \
 gnatdoc/docs/users_guide/_build

ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
override_dh_auto_build-indep: $(DOCS)
endif

# Note: see docs/users_guide/GPS/generated_hooks.py above.
# TODO: append SPHINXOPTS=-j$(BUILDER_JOBS) once #869098 is fixed.
$(DOCS):
	$(MAKE) -C $(dir $@) html latexpdf
	# Creates Python precompiled files in every imported module,
	# we do not want them installed.
	find . -name "*.pyc" -delete
override_dh_auto_clean::
	rm -fr $(DOCS)
	find . -name "*.pyc" -delete

######################################################################
# Mimic dh --with sphinxdoc with sphinx-common in Build-Depends-Indep.
.PHONY: override_dh_installdocs-indep
override_dh_installdocs-indep:
	dh_installdocs -i
	dh_sphinxdoc -i

.PHONY: override_dh_install-indep
override_dh_install-indep:
	dh_install -i
  # Documentation and license are not useful here.
	rm -f debian/gnat-gps-common/usr/share/gps/color_themes/themes/*/README.*
	rm -f debian/gnat-gps-common/usr/share/gps/color_themes/themes/*/LICENSE*
  # Should be a wishlist for dh_fixperms.
	chmod 644 debian/gnat-gps-common/usr/share/gps/icons/hicolor/scalable/16x16/gps-*.svg

# Mimic dh --with linktree, with dh-linktree in Build-Depends-Indep.
.PHONY: override_dh_link-indep
override_dh_link-indep:
	dh_link -i
	dh_linktree -i

.PHONY: override_dh_compress
override_dh_compress:
	dh_compress --all -X.xml -X.ads -X.adb -X.c -X.py

=== debian/watch ===
# See README.source.

version=4
opts=\
  repack,\
  compression=xz,\
  dversionmangle=s/.*\.//,\
  filenamemangle=s/^.*download=// \
https://qa.debian.org/cgi-bin/fakeupstream.cgi?upstream=adacore/gps \
.*gps-gpl@ANY_VERSION@-src@ARCHIVE_EXT@

## gnat-gps 17.0.2017

=== gps/Makefile ===
--- 
+++ 
@@ -22,9 +22,9 @@
 Build?=Debug
 
 ifeq ($(Build),Production)
-  GPRBUILD_BUILD_TYPE_FLAGS=-XBuild=Production -XGnatcoll_Build=Production -XOS=${OS}
+  GPRBUILD_BUILD_TYPE_FLAGS=-XBuild=Production -XGnatcoll_Build=Production -XOS=${OS} -XLIBRARY_TYPE=relocatable -XXMLADA_BUILD=relocatable
 else
-  GPRBUILD_BUILD_TYPE_FLAGS=-XBuild=Debug -XGnatcoll_Build=Debug -XOS=${OS}
+  GPRBUILD_BUILD_TYPE_FLAGS=-XBuild=Debug -XGnatcoll_Build=Debug -XOS=${OS} -XLIBRARY_TYPE=relocatable -XXMLADA_BUILD=relocatable
 endif
 
 .PHONY: default resources do_links all clean
@@ -40,7 +40,10 @@
 # gnat.adc (No_Tasking restriction) on all gnatcoll sources.
 all: resources do_links
 	cd ../kernel/src; ${PYTHON} hooks.py
-	$(GPRBUILD) $(GPRBUILD_FLAGS) -m -ws -P../spark/spark
+	cd ../kernel/generated; gnatcoll_db2ada -api=GPS.Kernel.Properties.Database -adacreate -dbmodel=../src/properties_schema.txt
+ifeq ($(OS),Windows_NT)
+	for f in ../kernel/generated/*; do cat $$f | tr -d '\015' > $$f-aux; mv -f $$f-aux $$f; done
+endif
 	$(GPRBUILD) $(GPRBUILD_FLAGS) -m -p -ws -XTP_TASKING=No_Tasking \
 	  $(GPRBUILD_BUILD_TYPE_FLAGS) -Pgps -largs `pkg-config gmodule-2.0 --libs`

=== debian/changelog ===
gnat-gps (17.0.2017-1ubuntu1) cosmic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - debian/control: gnat-gps: Recommend gdb | gdb-minimal.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 04 May 2018 09:41:41 +0200

gnat-gps (17.0.2017-1) unstable; urgency=medium

  * Upload to unstable.
  * Add sphinxdoc substvar for Built-Using.
  * Standards-Version: 4.1.4.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 24 Apr 2018 17:58:35 +0200

gnat-gps (17.0.2017-1~exp1) experimental; urgency=medium

  [Nicolas Boulenguez]
  * New upstream release GPL-2017.
    Drop packaging for gnatspark executable.
    Regenerate database Ada sources. Build-Depend: libgnatcoll-sqlite-bin.
    Package new release_notes_17 documentation.
    Disable libadalang support, dependency is not packaged.
  * Re-enable clang support, seems to link correctly now. Update to 3.8.
  * Build-Depends: drop obsolete version restriction on dpkg-dev.
  * Debheper 11. Simplifies installation of documentation.
  * gtk3-incompatibility.diff: goes with libgtkada17.0-dev, fixing
    gtkada with recent gtk3.
  * Build-Depend: python3-sphinx instead of deprecated python2 version.
  * Fix many incompatibilities with python3. Build-Depend: python*-six.
    Gather all python3-related fixes in a single diff to ease rebasing.
  * Remove trailing whitespaces in this changelog.
  * Tell lintian that welcome.html does not need doc-base registration.
  * Remove __pycache__ directories after removing .pyc contents.
  * Remove execution rights for some python modules.
  * Standards-Version: 4.1.3. No changes.
  * Allow gnat-gps-doc to satisfy Multi-Arch foreign dependencies.

  [Thierry Rascle <thierr26@free.fr>]
  * gnatdoc.diff closes: #861616.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 04 Mar 2018 00:05:32 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 XSBC-Original-Maintainer: Ludovic Brenta <lbrenta@debian.org>
 Uploaders: Xavier Grave <xavier.grave@csnsm.in2p3.fr>,
  Nicolas Boulenguez <nicolas@debian.org>
-Build-Depends: debhelper (>= 10), dpkg-dev (>= 1.16.1),
+Build-Depends: debhelper (>= 11),
  gnat,
  libgpr1-dev,
  libxmlada-unicode7-dev,
@@ -16,13 +16,15 @@
 # gprbuild removing auto.cgpr after the build.
  libtemplates-parser11.10.2-dev,
  pkg-config, libglib2.0-dev, libgtk-3-dev,
- libgtkada16.1.0-dev,
+ libgtkada17.0-dev,
  libgnatcoll-python16.1.0-dev,
  libgnatcoll16.1.0-dev,
- libgnatcoll-gtk16.1.0-dev,
+ libgnatcoll-gtk17.0-dev,
  libgnatcoll-sqlite16.1.0-dev,
- libgnatcoll-xref17.0.2017-dev
-# libclang-dev See TODO
+ libgnatcoll-xref17.0.2017-dev,
+ libclang-dev,
+ libgnatcoll-sqlite-bin
+# used by d/rules to generate gps-kernel-properties-database.ads.
 Build-Depends-Indep:
 # Sphinx uses graphs for Python inheritance trees, in gps.py for example.
  graphviz,
@@ -38,8 +40,10 @@
  sphinx-common,
 # other js libraries
  dh-linktree,
- python-sphinx
-Standards-Version: 4.1.0
+ python3-sphinx
+# Some gps modules are imported by sphinx.
+ ,python3-six
+Standards-Version: 4.1.4
 Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.gnat-gps
 Vcs-Mtn: mtn://www.ada-france.org?org.debian.gnat-gps
 Homepage: http://libre.adacore.com/libre/tools/gps
@@ -47,12 +51,16 @@
 Package: gnat-gps
 Architecture: any
 Depends: gnat-gps-common (=${source:Version}), ${shlibs:Depends}, ${misc:Depends},
+# Required to generate the GTK binding at run time.
+ gir1.2-gtk-3.0,
 # Required for any compilation.
  gprbuild,
 # Required by the Python scripts describing the GUI.
  python-gi,
 # libgnatcoll-sqlite-bin provides gnatinspect and gnat-gps runs it.
  libgnatcoll-sqlite-bin
+# Some gps modules are patched for python2&3.
+ ,python-six
 Recommends: gnat (>= 4.9), gdb | gdb-minimal (>= 6.8),
  gnat-gps-doc (= ${source:Version})
  ,python-jedi
@@ -89,7 +97,9 @@
 
 Package: gnat-gps-doc
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}, ${sphinxdoc:Depends}
+Built-Using: ${sphinxdoc:Built-Using}
 Recommends: ada-reference-manual-2012
 Section: doc
 Description: integrated development environment for C and Ada (documentation)

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 ##############
 
 # Copyright (c) 2003-2006, 2011-2014 Ludovic Brenta <lbrenta@debian.org>
-# Copyright (c) 2010-2017 Nicolas Boulenguez <nicolas@debian.org>
+# Copyright (c) 2010-2018 Nicolas Boulenguez <nicolas@debian.org>
 
 # This build script is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License as
@@ -36,9 +36,11 @@
 
 PKG_CONFIG_LIBRARIES := gtk+-3.0 glib-2.0
 
-# CLANG_VERSION := $(shell dpkg -s libclang-dev \
-#   | sed -nr '/^Depends: libclang-(.*)-dev.*/{s//\1/p;q}')
-# LIBS := -L/usr/lib/llvm-$(CLANG_VERSION)/lib -lclang -lstdc++
+CLANG_VERSION := $(shell dpkg -s libclang-dev \
+  | sed -nr '/^Depends: libclang-(.*)-dev.*/{s//\1/p;q}')
+LIBS := -L/usr/lib/llvm-$(CLANG_VERSION)/lib -lclang -lstdc++
+
+PYTHON := python
 
 ######################################################################
 %:
@@ -50,20 +52,6 @@
 
 ######################################################################
 
-GPS_WELCOME := docs/gps-welcome.html docs/gps-welcome-public.html
-override_dh_auto_build-indep: $(GPS_WELCOME)
-$(GPS_WELCOME): %: %.in
-	sed -e 's/@GPS_VERSION@/$(DEB_VERSION_UPSTREAM)/' $< > $@
-override_dh_auto_clean::
-	rm -f $(GPS_WELCOME)
-
-PROTOCOLS_PY := share/support/core/protocols.py
-override_dh_auto_build-indep: $(PROTOCOLS_PY)
-$(PROTOCOLS_PY): %: %.in
-	sed -e 's/@SSH_ESCAPE@/~/' $< > $@
-override_dh_auto_clean::
-	rm -f $(PROTOCOLS_PY)
-
 # Note: the script generates both Ada and Python sources, the latter
 # are embedded into the users_guide.
 override_dh_auto_build-arch: docs/users_guide/GPS/generated_hooks.py
@@ -71,11 +59,11 @@
 docs/users_guide/GPS/generated_hooks.py: kernel/src/hooks.py
 	rm -fr kernel/generated
 	mkdir kernel/generated
-	cd kernel/src && python hooks.py
+	cd kernel/src && $(PYTHON) hooks.py
 override_dh_auto_clean::
 	rm -fr kernel/generated docs/users_guide/GPS/generated_hooks.py
 
-# override_dh_auto_build-arch: libclang/gen
+override_dh_auto_build-arch: libclang/gen
 libclang/gen:
 	$(MAKE) -C libclang \
 	  CLANG_SRC_DIR=/usr/lib/llvm-$(CLANG_VERSION) \
@@ -87,16 +75,9 @@
 override_dh_auto_build-indep: $(GNAT_SWITCHES_PY)
 $(GNAT_SWITCHES_PY): distrib/gnat_switches.py \
                      gnat/building_executable_programs_with_gnat.rst
-	python distrib/gnat_switches.py > $@
+	$(PYTHON) distrib/gnat_switches.py > $@
 override_dh_auto_clean::
 	rm -f $(GNAT_SWITCHES_PY)
-
-GNAT_RUNTIME_PLUG_IN := share/support/core/runtime.py
-override_dh_auto_build-indep: $(GNAT_RUNTIME_PLUG_IN)
-share/support/core/runtime.py: distrib/from_impunit.pl gnat/impunit.adb
-	cd distrib && perl from_impunit.pl
-override_dh_auto_clean::
-	rm -f  $(GNAT_RUNTIME_PLUG_IN)
 
 ######################################################################
 override_dh_auto_build-arch:
@@ -107,10 +88,23 @@
 override_dh_auto_clean::
 	rm -f obj/*
 
-CONFIG_ADS := common/core/src/config.ads
-override_dh_auto_build-arch: $(CONFIG_ADS)
-$(CONFIG_ADS): %: %.in
-	sed -e 's/@CURRENT_YEAR@/2015/' \
+database := kernel/generated/gps-kernel-properties-database.ads
+override_dh_auto_build-arch: $(database)
+$(database):
+	cd $(dir $@) && gnatcoll_db2ada -api=GPS.Kernel.Properties.Database -adacreate -dbmodel=../src/properties_schema.txt
+override_dh_auto_clean::
+	rm -f $(database)
+
+######################################################################
+configured := \
+  common/core/src/config.ads \
+  docs/gps-welcome.html \
+  docs/gps-welcome-public.html \
+  share/support/core/protocols.py
+override_dh_auto_configure: $(configured)
+$(configured): %: %.in
+	sed \
+	    -e 's/@CURRENT_YEAR@/2017/' \
 	    -e 's/@GPS_VERSION@/$(DEB_VERSION_UPSTREAM)/' \
 	    -e 's/@TARGET@/$(DEB_HOST_GNU_TYPE))/' \
 	    -e 's/@TARGET_IS_DARWIN@/False/' \
@@ -126,9 +120,11 @@
 	    -e 's/@DIFF3_CMD@/diff3/' \
 	    -e 's/@PATCH_CMD@/patch/' \
 	    -e 's/@EXECUTION_WINDOW@/True/' \
-	    -e 's/@CHARSET@/UTF-8/' $< > $@
+	    -e 's/@CHARSET@/UTF-8/' \
+	    -e 's/@SSH_ESCAPE@/~/' \
+	    $< > $@
 override_dh_auto_clean::
-	rm -f $(CONFIG_ADS)
+	rm -f $(configured)
 
 ######################################################################
 DOCS := \
@@ -136,22 +132,28 @@
  docs/tutorial/_build \
  docs/programmers_guide/_build \
  docs/release_notes/build \
+ docs/release_notes_17/build \
  gnatdoc/docs/users_guide/_build
 
 ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
 override_dh_auto_build-indep: $(DOCS)
+  # Rename one of the two ReleaseNotes.pdf.
+	cd docs/release_notes_17/build/latex && cp -f ReleaseNotes.pdf ReleaseNotes_17.pdf
+  # Sphinx creates Python precompiled files in every imported module,
+  # we do not want them installed.
+	find . -name "*.pyc" -delete
+	find . -type d -name "__pycache__" -print0 | xargs -r0 rmdir
 endif
 
 # Note: see docs/users_guide/GPS/generated_hooks.py above.
 # TODO: append SPHINXOPTS=-j$(BUILDER_JOBS) once #869098 is fixed.
 $(DOCS):
 	$(MAKE) -C $(dir $@) html latexpdf
-	# Creates Python precompiled files in every imported module,
-	# we do not want them installed.
-	find . -name "*.pyc" -delete
+
 override_dh_auto_clean::
 	rm -fr $(DOCS)
 	find . -name "*.pyc" -delete
+	find . -type d -name "__pycache__" -print0 | xargs -r0 rmdir
 
 ######################################################################
 # Mimic dh --with sphinxdoc with sphinx-common in Build-Depends-Indep.
@@ -168,6 +170,13 @@
 	rm -f debian/gnat-gps-common/usr/share/gps/color_themes/themes/*/LICENSE*
   # Should be a wishlist for dh_fixperms.
 	chmod 644 debian/gnat-gps-common/usr/share/gps/icons/hicolor/scalable/16x16/gps-*.svg
+  # Probably errors in upstream package.
+	chmod 644 debian/gnat-gps-common/usr/share/gps/plug-ins/spark2014.py
+	chmod 644 debian/gnat-gps-common/usr/share/gps/support/core/gps_utils/internal/dialogs.py
+  # Removed by upstream install process in Makefile.
+	rm -f debian/gnat-gps-common/usr/share/gps/icons/hicolor/scalable/*sketch
+  # libadalang is disabled because it is not packaged in Debian
+	rm -f debian/gnat-gps-common/usr/share/gps/support/core/lal.py
 
 # Mimic dh --with linktree, with dh-linktree in Build-Depends-Indep.
 .PHONY: override_dh_link-indep

## gnat-gps 18

=== testsuite/Makefile ===
GPRBUILD=gprbuild
GPRCLEAN=gprclean

SYS := $(shell gcc -dumpmachine)
ifeq ($(OS),Windows_NT)
        OS := Windows_NT
else
        ifneq (, $(findstring darwin, $(SYS)))
OS := osx
else
        OS := unix
endif
endif

all default: package
	$(GPRBUILD) -P testsuite_drivers.gpr -m -XOS=${OS} -j0 -XLIBRARY_TYPE=relocatable -XXMLADA_BUILD=relocatable

package:
	mkdir -p share/doc
	cp ../share/predefined_ada.xml share
	cp ../docs/users_guide/GPS.rst share/doc
	cp ../docs/users_guide/GPS.Browsers.rst share/doc
	cp ../docs/users_guide/generate.py share/doc
clean:
	$(GPRCLEAN) -P testsuite_drivers.gpr
	rm -rf share

=== share/templates/ajis_hello/Makefile ===
ifeq ($(OS),Windows_NT)
	BUILD_CLASSPATH="./src_java/;./binding/java;$$CLASSPATH"
	RUN_CLASSPATH="bin;$$CLASSPATH"
else
	BUILD_CLASSPATH="./src_java/:./binding/java:$$CLASSPATH"
	RUN_CLASSPATH="bin:$$CLASSPATH"
endif


all: gen_binding build_ada build_java run_java

gen_binding:
	ada2java -P ajis_hello.gpr src_ada/hello.ads -o binding/ada -c binding/java -L @_project_name_@_lib -b com.adacore.example

build_ada:
	gprbuild -p -P binding/ada/@_project_name_@_lib.gpr

build_java:
	CLASSPATH=$(BUILD_CLASSPATH) \
	javac src_java/com/adacore/example/@_Main_Name_@.java -d bin

run_java:
	CLASSPATH=$(RUN_CLASSPATH) \
	PATH="binding/ada/lib:$$PATH" \
	java com.adacore.example.@_Main_Name_@

=== debian/changelog ===
gnat-gps (18-5ubuntu1) disco; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Build with -O2 on ppc64el (avoiding a FTBFS).
    - debian/control: gnat-gps: Recommend gdb | gdb-minimal.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 11 Dec 2018 22:05:04 +0100

gnat-gps (18-5) unstable; urgency=medium

  * Disable 32 bits builds, affected by #913371.
    The problem was hidden by some 64 bits chroot.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 11 Dec 2018 14:43:22 +0100

gnat-gps (18-4ubuntu1) disco; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Build with -O2 on ppc64el (avoiding a FTBFS).
    - debian/control: gnat-gps: Recommend gdb | gdb-minimal.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 03 Dec 2018 20:00:37 +0100

gnat-gps (18-4) unstable; urgency=medium

  * Stop attempting to build on armel mips mipsel to circumvent #913371.
  * Reenable parallelism.
  * Update the copyright year in documentation automatically.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 02 Dec 2018 21:32:20 +0100

gnat-gps (18-3ubuntu1) disco; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Build with -O2 on ppc64el (avoiding a FTBFS).
    - debian/control: gnat-gps: Recommend gdb | gdb-minimal.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 01 Dec 2018 05:29:17 +0100

gnat-gps (18-3) unstable; urgency=medium

  * On 32 bits archs, forbid parallelism to use less memory. Closes: 913371.
  * Link with --as-needed and similar options.
  * Standards-Version: 4.2.1.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 11 Nov 2018 11:49:30 +0100

gnat-gps (18-2ubuntu2) disco; urgency=medium

  * Build with -O2 on ppc64el (avoiding a FTBFS).

 -- Matthias Klose <doko@ubuntu.com>  Mon, 12 Nov 2018 08:11:11 +0100

gnat-gps (18-2ubuntu1) disco; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - debian/control: gnat-gps: Recommend gdb | gdb-minimal.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 10 Nov 2018 21:58:49 +0100

gnat-gps (18-2) unstable; urgency=medium

  * Rebuild in unstable for gnat-8 transition.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 27 Oct 2018 15:09:46 +0200

gnat-gps (18-1) experimental; urgency=medium

  * New upstream release.
  * Replace gnatcoll_gtk dependency with gnatcoll_extras subdirectory.
    Directly depend on python-gi-dev, libpython2.7-dev.
  * New valgrind binding, only used on amd64 and i386.
  * Standards-Version: 4.2.0. Rules-Requires-Root: no.
  * Drop obsolete Break/Replace.
  * New documentation docs/release_notes_62.
  * Fix diff offset gnatdoc.diff, see end of bug log for #861616.
  * Build with gnatcoll_sqlite2ada instead of obsolete gnatcoll_db2ada.
  * Enable parallel documentation build now that #869098 is fixed.
  * Fix permissions for tomorrow GTK theme.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 07 Aug 2018 07:46:16 +0200

gnat-gps (17.0.2017-2) experimental; urgency=medium

  * Rebuild with gnat-8 and updated xmlada, gpr1, gtkada, gnatcoll.
    Cherry-pick two upstream commits fixing new errors.
    Remove -lstdc++ from linker options for libclang.
  * Remove watch file and explain why in README.source.
  * Update upstream Homepage.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 10 May 2018 12:33:19 +0200

=== debian/control ===
--- 
+++ 
@@ -1,30 +1,32 @@
 Source: gnat-gps
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Ludovic Brenta <lbrenta@debian.org>
+Maintainer: Ludovic Brenta <lbrenta@debian.org>
 Uploaders: Xavier Grave <xavier.grave@csnsm.in2p3.fr>,
  Nicolas Boulenguez <nicolas@debian.org>
 Build-Depends: debhelper (>= 11),
  gnat,
- libgpr1-dev,
- libxmlada-unicode7-dev,
- libxmlada-input7-dev,
- libxmlada-sax7-dev,
- libxmlada-dom7-dev,
+ libgpr2-dev,
+ libxmlada-unicode8-dev,
+ libxmlada-input8-dev,
+ libxmlada-sax8-dev,
+ libxmlada-dom8-dev,
  gprbuild (>= 2017),
 # gprbuild removing auto.cgpr after the build.
- libtemplates-parser11.10.2-dev,
+ libtemplates-parser12-dev,
  pkg-config, libglib2.0-dev, libgtk-3-dev,
- libgtkada17.0-dev,
- libgnatcoll-python16.1.0-dev,
- libgnatcoll16.1.0-dev,
- libgnatcoll-gtk17.0-dev,
- libgnatcoll-sqlite16.1.0-dev,
- libgnatcoll-xref17.0.2017-dev,
+ libgtkada18-dev,
+ libgnatcoll-python17-dev,
+ libgnatcoll17-dev,
+ libgnatcoll-sqlite-bin (>= 18),
+# d/rules uses gnatcoll_sqlite2ada
+ libgnatcoll-sqlite17-dev,
+ libgnatcoll-xref18-dev,
  libclang-dev,
- libgnatcoll-sqlite-bin
-# used by d/rules to generate gps-kernel-properties-database.ads.
+ libpython2.7-dev,
+# gnatcoll_extras/src/python_support_gtk.c
+ python-gi-dev,
+# gnatcoll_extras/src/python_support_gtk.c
 Build-Depends-Indep:
 # Sphinx uses graphs for Python inheritance trees, in gps.py for example.
  graphviz,
@@ -43,13 +45,15 @@
  python3-sphinx
 # Some gps modules are imported by sphinx.
  ,python3-six
-Standards-Version: 4.1.4
+Standards-Version: 4.2.1
+Rules-Requires-Root: no
 Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.gnat-gps
 Vcs-Mtn: mtn://www.ada-france.org?org.debian.gnat-gps
-Homepage: http://libre.adacore.com/libre/tools/gps
+Homepage: https://www.adacore.com/community
 
 Package: gnat-gps
-Architecture: any
+# Gcc exhausts virtual address space on true 32 bits machines, see #913371.
+Architecture: amd64 arm64 mips64el ppc64el s390x alpha ia64 kfreebsd-amd64 ppc64 riscv64 sparc64
 Depends: gnat-gps-common (=${source:Version}), ${shlibs:Depends}, ${misc:Depends},
 # Required to generate the GTK binding at run time.
  gir1.2-gtk-3.0,
@@ -116,8 +120,6 @@
 Package: gnat-gps-common
 Architecture: all
 Depends: ${misc:Depends}
-Breaks: gnat-gps (<< 5.0)
-Replaces: gnat-gps (<< 5.0)
 Description: integrated development environment for C and Ada (common files)
  GNAT Programming Studio is a complete integrated development environment
  that gives access to a wide range of tools and integrates them smoothly.

=== debian/rules ===
--- 
+++ 
@@ -29,16 +29,24 @@
 gnat_version := $(shell gnatgcc -dumpversion | sed 's/\..*//')
 
 DEB_BUILD_MAINT_OPTIONS := hardening=+all
+ifneq (,$(filter $(DEB_HOST_ARCH), ppc64el))
+  export DEB_CFLAGS_MAINT_APPEND = -O2
+  export DEB_CFLAGS_MAINT_STRIP = -O3
+  export DEB_ADAFLAGS_MAINT_APPEND = -O2
+  export DEB_ADAFLAGS_MAINT_STRIP = -O3
+endif
+DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed -Wl,--no-allow-shlib-undefined \
+  -Wl,--no-copy-dt-needed-entries -Wl,--no-undefined
 include /usr/share/dpkg/default.mk
 # Set CFLAGS (handling noopt from DEB_BUILD_OPTIONS), LDFLAGS,
 # DEB_HOST_GNU_TYPE, DEB_HOST_ARCH, DEB_VERSION...
 include /usr/share/ada/debian_packaging-$(gnat_version).mk
 
-PKG_CONFIG_LIBRARIES := gtk+-3.0 glib-2.0
+PKG_CONFIG_LIBRARIES := gtk+-3.0 glib-2.0 pygobject-3.0 python-2.7
 
 CLANG_VERSION := $(shell dpkg -s libclang-dev \
   | sed -nr '/^Depends: libclang-(.*)-dev.*/{s//\1/p;q}')
-LIBS := -L/usr/lib/llvm-$(CLANG_VERSION)/lib -lclang -lstdc++
+LIBS := -L/usr/lib/llvm-$(CLANG_VERSION)/lib -lclang
 
 PYTHON := python
 
@@ -81,8 +89,8 @@
 
 ######################################################################
 override_dh_auto_build-arch:
-	gprbuild $(BUILDER_OPTIONS) -k -Pdebian/build_gps.gpr \
-	  $(foreach v,ADAFLAGS CFLAGS CPPFLAGS LDFLAGS LIBS,"-X$(v)=$($(v))") \
+	gprbuild $(BUILDER_OPTIONS) -k debian/build_gps.gpr \
+	  $(foreach v,ADAFLAGS CFLAGS CPPFLAGS DEB_HOST_GNU_TYPE LDFLAGS LIBS,"-X$(v)=$($(v))") \
 	  "-XPKG_CONFIG_CFLAGS=`pkg-config --cflags $(PKG_CONFIG_LIBRARIES)`" \
 	  "-XPKG_CONFIG_LIBS=`pkg-config --libs $(PKG_CONFIG_LIBRARIES)`"
 override_dh_auto_clean::
@@ -91,7 +99,7 @@
 database := kernel/generated/gps-kernel-properties-database.ads
 override_dh_auto_build-arch: $(database)
 $(database):
-	cd $(dir $@) && gnatcoll_db2ada -api=GPS.Kernel.Properties.Database -adacreate -dbmodel=../src/properties_schema.txt
+	cd $(dir $@) && gnatcoll_sqlite2ada -api=GPS.Kernel.Properties.Database -adacreate -dbmodel=../src/properties_schema.txt
 override_dh_auto_clean::
 	rm -f $(database)
 
@@ -104,7 +112,7 @@
 override_dh_auto_configure: $(configured)
 $(configured): %: %.in
 	sed \
-	    -e 's/@CURRENT_YEAR@/2017/' \
+	    -e 's/@CURRENT_YEAR@/20$(DEB_VERSION_UPSTREAM)/' \
 	    -e 's/@GPS_VERSION@/$(DEB_VERSION_UPSTREAM)/' \
 	    -e 's/@TARGET@/$(DEB_HOST_GNU_TYPE))/' \
 	    -e 's/@TARGET_IS_DARWIN@/False/' \
@@ -133,12 +141,14 @@
  docs/programmers_guide/_build \
  docs/release_notes/build \
  docs/release_notes_17/build \
+ docs/release_notes_62/build \
  gnatdoc/docs/users_guide/_build
 
 ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
 override_dh_auto_build-indep: $(DOCS)
-  # Rename one of the two ReleaseNotes.pdf.
+  # Give distinct names to release notes.
 	cd docs/release_notes_17/build/latex && cp -f ReleaseNotes.pdf ReleaseNotes_17.pdf
+	cd docs/release_notes_62/build/latex && cp -f ReleaseNotes.pdf ReleaseNotes_62.pdf
   # Sphinx creates Python precompiled files in every imported module,
   # we do not want them installed.
 	find . -name "*.pyc" -delete
@@ -146,14 +156,20 @@
 endif
 
 # Note: see docs/users_guide/GPS/generated_hooks.py above.
-# TODO: append SPHINXOPTS=-j$(BUILDER_JOBS) once #869098 is fixed.
 $(DOCS):
-	$(MAKE) -C $(dir $@) html latexpdf
+	$(MAKE) -C $(dir $@) html latexpdf SPHINXOPTS=-j$(BUILDER_JOBS)
 
 override_dh_auto_clean::
 	rm -fr $(DOCS)
 	find . -name "*.pyc" -delete
 	find . -type d -name "__pycache__" -print0 | xargs -r0 rmdir
+
+# A logo referenced in index.rst but missing.
+docs/release_notes/build: docs/release_notes/gps18.png
+docs/release_notes/gps18.png:
+	cd docs/release_notes && ln -s ../release_notes_62/gps6.png gps18.png
+override_dh_auto_clean::
+	rm -f docs/release_notes/gps18.png
 
 ######################################################################
 # Mimic dh --with sphinxdoc with sphinx-common in Build-Depends-Indep.
@@ -170,6 +186,7 @@
 	rm -f debian/gnat-gps-common/usr/share/gps/color_themes/themes/*/LICENSE*
   # Should be a wishlist for dh_fixperms.
 	chmod 644 debian/gnat-gps-common/usr/share/gps/icons/hicolor/scalable/16x16/gps-*.svg
+	chmod 644 debian/gnat-gps-common/usr/share/gps/color_themes/themes/tomorrow/*.tmTheme
   # Probably errors in upstream package.
 	chmod 644 debian/gnat-gps-common/usr/share/gps/plug-ins/spark2014.py
 	chmod 644 debian/gnat-gps-common/usr/share/gps/support/core/gps_utils/internal/dialogs.py
